/* ---------------------------------------------------
 * module description : 
 * module file name   : Code.C
 * created            : 9/25/97 8:12:08 PM
 * --------------------------------------------------- */

/* CAN Demos
 *
 * This is the simplest CAN demo.  It uses assembly 
 * routines to access the CAN.  The C routines simply
 * transmit and receive data on the CAN.
 *
 * This program transmits or receives a single byte of
 * data.  Only message object 1 of the CAN controller 
 * is used. The assembly routine CanSetup configures 
 * message object 1 to transmit if its argument is 
 * nonzero (e.g., nTransmit=1).  If the argument is 0
 * (nTransmit=0) then message object 1 is configured 
 * to receive messages.  The messages identifier is set
 * to 0. 
 *
 * When transmitting, the program repeatedly sends 
 * bytes from 0 to 99.  A little delay is placed after
 * each transmission to make the messages more visible
 * on screen.  When receiving, the program simply
 * reports the value of the data byte received.  No 
 * attempt is made to detect or recover from errors.
 *
 * Connect two boards through the CAN bus.  Configure
 * one to receive and the other, to transmit.
 *
 * The program consists of a single loop to continuously
 * transmit or receive bytes.  Press any key to terminate 
 * the program.
 *
 */
// --- constants ---
#define ESC 0x1B     // escape key

// --- prototypes of assembly routines ---
void CanSetup(int nTransmit);
int  CanCheckMsg(void);
int  CanGetMsg(void);
void CanSendMsg(int);

main (){
int n, nMsg=0, nTransmit=1; // set nTransmit=1 to transmit, 0 to receive

 CanSetup(nTransmit);

 while(1)
  {
   if(nTransmit)
    {
     CanSendMsg(nMsg);
     nMsg++;
     nMsg%=100;
     SendStr("\nsent : ");
     SendInt(nMsg);
     for(n=0; n<10000; n++);  // waste a little time
     }
    else
     {
      while(CanCheckMsg()==0);
      nMsg=CanGetMsg();
      SendStr("\nreceived : ");
      SendInt(nMsg);
      }

   if(PeekChar()==ESC) break;  // break when space bar is pressed
   }
}

