;  READS166 Demo Programs
;
;  Utility and Support Routines
;
;  (C) 1993-1995 by RIGEL Corporation
;
;  P.O. Box 90040 
;  Gainesville, FL, 32607
;
;  Tel: (904) 373-4629
;  BBS: (904) 377-4435
;
;
; --------------------------------------------------------------------------
; Module:       r66util.inc
;
; Description:  Support routines for the various demo programs.  
;               This module may be included in your programs using the
;
;               #include "r66util.inc"
;
;               pseudo-op (compiler directive) in READS166.
;
;
; List of Routines:
;             ASCBIN
;             BINASC
;             CRLF
;             GETBYT
;             GETCHR
;             INKEY
;             PAUSE
;             PRINT
;             PRSPHX
;             PRTHEX
;             PRWDHX
;             SNDCHR
; --------------------------------------------------------------------------
; constants
     CR      equ    0dh    ; carrige return
     LF      equ    0ah    ; line feed

; --------------------------------------------------------------------------
      EVEN   ; make sure we start at a word boundary (even address)
; --------------------------------------------------------------------------
CRLF: 
      push    r0
      mov     r0, #(DATA16 0dh)
      calla   cc_UC, sndchr
      mov     r0, #(DATA16 0ah)
      calla   cc_UC, sndchr
      pop     r0
      ret
; --------------------------------------------------------------------------
SNDCHR:
        mov     S0TBUF, r0
sndchr1:
        jnb     S0TIR, sndchr1
        bclr    S0TIR
        ret
; --------------------------------------------------------------------------
GETCHR:
        jnb     S0RIR, getchr
        mov     r0, S0RBUF
        bclr    S0RIR
        ret
; --------------------------------------------------------------------------
INKEY:
        jnb     S0RIR, inkey_done
        mov     r0, S0RBUF
        and     r0, #0ffh
        bclr    S0RIR
        ret
inkey_done:
        mov     r0, #0
        ret
; --------------------------------------------------------------------------
BINASC: 
       and     r0, #(DATA16 0Fh)
       cmpb    RL0, #0Ah
       jmpr     cc_UGE, bahexchr
       addb     RL0, #(DATA16 30h)
       ret
bahexchr:
       addb     RL0, #(DATA16 37h)
       ret
; --------------------------------------------------------------------------
PRTHEX:
       push    r0
       and     r0, #(DATA16 0FFh)
       push    r0
       shr     r0, #4 
       calla   cc_UC, binasc
       calla   cc_UC, sndchr
       pop     r0 
       calla   cc_UC, binasc
       calla   cc_UC, sndchr
       pop     r0
       ret
; --------------------------------------------------------------------------
PRWDHX:
       push    r0
       and     r0, #(DATA16 0F000h)
       shr     r0, #12 
       calla   cc_UC, binasc
       calla   cc_UC, sndchr
       pop     r0

       push    r0
       and     r0, #(DATA16 0F00h)
       shr     r0, #8
       calla   cc_UC, binasc
       calla   cc_UC, sndchr
       pop     r0

       push    r0
       and     r0, #(DATA16 0F0h)
       shr     r0, #4
       calla   cc_UC, binasc
       calla   cc_UC, sndchr
       pop     r0

       push    r0
       and     r0, #(DATA16 0Fh)
       calla   cc_UC, binasc
       calla   cc_UC, sndchr
       pop     r0

       ret
; --------------------------------------------------------------------------
PRSPHX:
       push    r0
       push    r0
       mov     r0, #' '
       calla   cc_UC, sndchr
       pop     r0
       calla   cc_UC, prthex
       pop     r0
       ret
; --------------------------------------------------------------------------
PRINT:
prt1:
        movb    RL0, [r1]
        cmpb    RL0, #(DATA16 0)
        jmpa    cc_EQ, prt2
        calla   cc_UC, sndchr
        add     r1, #(DATA16 1)
        jmpr    cc_UC, prt1
prt2:
        ret
; --------------------------------------------------------------------------
PAUSE:
       cmpd1   r0, #0
       jmpr    cc_ne, pause
       ret

; --------------------------------------------------------------------------
ASCBIN:
        bclr    R15.0
        cmpb    RL0, #30h
        jmpr    cc_ULT, error
        cmpb    RL0, #39h
        jmpr    cc_ULE, dec
        cmpb    RL0, #41h
        jmpr    cc_ULT, error
        cmpb    RL0, #46h
        jmpr    cc_ULE, caphex
        cmpb    RL0, #61h
        jmpr    cc_ULT, error
        cmpb    RL0, #66h
        jmpr    cc_ULE, lowerhex
        jmpr    cc_UC, error
dec:
        subb    RL0, #30h
        ret
caphex:
        subb    RL0, #37h
        ret
lowerhex:
        subb    RL0, #57h
        ret
error:
        bset    R15.0
        ret
; --------------------------------------------------------------------------
GETBYT:
       calla   cc_UC, getchr
       cmpb    RL0, #0dh       ; see if first char is <cr>
       jmpr    cc_NE, gbyte1
       bset    R15.0           ; error flag
       ret
gbyte1:
       calla   cc_UC, sndchr
       calla   cc_UC, ascbin
       rol     r0, #4
       movb    RL3, RL0
       calla   cc_UC, getchr
       calla   cc_UC, sndchr
       cmpb    RL0, #0dh       ; see if second char is <cr>
       jmpr    cc_NE, gbyt2
       movb    RL0, RL3
       ror     r0, #4
       ret
gbyt2:
       calla   cc_UC, ascbin
       orb     RL0, RL3
       ret
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
      EVEN   ; make sure we end at a word boundary (even address)
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
; end of "r66util.inc"...
